/*
	boxcar
	<c> Risto Holopainen 2008
	
	boxcar-filter --- TIIR
	
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
*/

#ifndef BOXCAR_H
#define BOXCAR_H


class boxcar
{
	public:
		boxcar(unsigned int sz=16);	// length of filter
		~boxcar();
		float filter(float);			// korrekt

	private:
		unsigned int N;
		unsigned int n, p;
		float y, y1, norm;
		float *buf;
};


boxcar::boxcar(unsigned int sz)
{
	N = sz+1;
	buf = new float[N];
	for(unsigned int i=0; i<N; i++)
		buf[i] = 0;
	y1 = 0;
	norm = 1.0/sz;
	n = 0;
	p = 1;
}

boxcar::~boxcar()
{
	buf = 0;
	delete buf;
}


float boxcar::filter(float x)
{
	buf[n] = norm*x;
	if(++n < N)
		y =	buf[n-1] - buf[n] + y1;
	else 
		{
		y = buf[n-1] - buf[0] + y1;	
		n = 0;
		}

	y1 = y;
	return y;
}



#endif
