/*
	variclox.h
	Copyright Risto Holopainen 2021
	
	use clock as quasi-random source
	WARNING:
	incredibly slow functions!
	No guarantees of any sort!
	Consider this a proof of concept.


	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
 
*/

#include <ctime>
#include <cstdio>


inline bool toss()
{
	return (bool) (clock() & 1);
}


inline int toss3()
{
	return (clock() & 3);
}


inline int toss_m(int M)
{
	return (clock() % M);
}


double trand()
{
	// returns range -1 < x < 1
	
	double xi = toss3();
	xi += toss3()/2.;
	xi += toss3()/3.;
	xi += toss3()/4.;
	xi += toss3()/5.;
	xi += toss3()/6.;

	return 0.2721088 * xi - 1.0;
}


double rund()
{
	// -11/8 < xi < 5/4
	double xi = (clock() & 1) - .5;
	xi += .250 * (clock() & 3);
	xi -= .125 * (clock() & 7);
	return xi;
}



double trind()
{
	// return -1 < psi < +1
	int psi = (clock() & 7);
	psi |= (clock() & 15);		// 0--15
	psi += (clock() & 31);		// 0--46
	psi -= (clock() & 63);		// -63--46

	return 0.01834862 * (psi + 8.5);
}



double trix()
{
	int xi = 1 + (clock() & 127);
	int ju = 1 + (clock() & 63);
	int po = 1 + (clock() & 31);
	int ma = (xi ^ ju) + (ju | po) - (xi & po);

	double ze = (ma == 0) ? 0 : 1.0/ma;
	ze += 1.0/xi;
	ze -= 1.0 / ju + 2.0 / po;
	return ze;
}



double gaussian(unsigned int N=25)
{
	double x, s = 0;
	for(unsigned int i=0; i<N; i++)
		{
		x = trind();
		s += x;
		}
	return s / N;
}
